//////////////////////////////////////////////////////////////////
// (c) Copyright 2003  by Jeongnim Kim 
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
/** @file VarList.h
 * @brief Define VarRegistry 
 */
#ifndef QMCPLUSPLUS_OPTIMIZE_VARREGISTRY_H
#define QMCPLUSPLUS_OPTIMIZE_VARREGISTRY_H
#include <map>

/** Set of variables that can be modified during optimizations
 */
template<class T>
struct VarRegistry: public std::map<std::string,T> {

  typedef typename std::map<std::string,T>::iterator iterator;

  void print(std::ostream& os) 
  {
    iterator it(this->begin());
    os << "Optimizable variable list " << std::endl;
    while(it != this->end())
    {
      os << (*it).first << " " << (*it).second << std::endl;
      ++it;
    }
  }

};
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 1757 $   $Date: 2007-02-17 16:28:14 -0600 (Sat, 17 Feb 2007) $
 * $Id: VarList.h 1757 2007-02-17 22:28:14Z jnkim $ 
 ***************************************************************************/
